PKILL(1)

NAME
pkill, pgrep, prenice - find or signal processes by name

SYNOPSIS
pgrep [-filnqvx] [-d delim] [-G gid] [-g pgrp] [-P ppid] [-s sid] [-t tty] [-U uid] [-u euid] pattern ...
pkill [-signal] [-filnvx] [-G gid] [-g pgrp] [-P ppid] [-s sid] [-t tty] [-U uid] [-u euid] pattern ...
prenice [-l] priority pattern ...

DESCRIPTION
The pgrep command searches the process table on the running system and prints the process IDs of all processes that match the criteria given on the command line.

The pkill command searches the process table on the running system and signals all processes that match the criteria given on the command line.

The prenice command searches the process table on the running system and sets the priority of all processes that match the criteria given on the command line.

By default, matching applies to any substring of the command name (argv[0]), but options may be used to change this. Patterns are specified using extended regular expressions (see re_format(7)).

The following options are available for pkill and pgrep:

-d delim
    Specify a delimiter to be printed between each process ID. The default is a newline. This option can only be used with the pgrep command.

-f  Match against full argument lists. The default is to match against process names.

-G gid
    Restrict matches to processes with a real group ID in the comma-separated list gid.

-g pgrp
    Restrict matches to processes with a process group ID in the comma-separated list pgrp. The value zero is taken to mean the process group ID of the running pgrep or pkill command.

-i  Ignore case distinctions in both the process table and the supplied pattern.

-l  Long output. Print the process name in addition to the process ID for each matching process. If used in conjunction with -f, print the process ID and the full argument list for each matching process.

-n  Match only the most recently created process, if any.

-P ppid
    Restrict matches to processes with a parent process ID in the comma-separated list ppid.

-s sid
    Restrict matches to processes with a session ID in the comma-separated list sid. The value zero is taken to mean the session ID of the running pgrep or pkill command.

-t tty
    Restrict matches to processes associated with a terminal in the comma-separated list tty. Terminal names may be specified as a fully qualified path, in the form ‘ttyXX’, or ‘pts/N’, (where XX is any pair of letters, and N is a number), or the shortened forms ‘XX’ or ‘N’. A single dash (‘-’) matches processes not associated with a terminal.

-U uid
    Restrict matches to processes with a real user ID in the comma-separated list uid.

-u euid
    Restrict matches to processes with an effective user ID in the comma-separated list euid.

-v  Reverse the sense of the matching; display processes that do not match the given criteria.

-x  Require an exact match of the process name, or argument list if -f is given. The default is to match any substring.

-signal
    A non-negative decimal number or symbolic signal name specifying the signal to be sent instead of the default TERM. This option is valid only when given as the first argument to pkill.

The following option is also available for pgrep:

-q  Quiet; do not write anything to standard output.

The -l flag is also available for prenice.

Note that a running pgrep, pkill, or prenice process will never consider itself or system processes (kernel threads) as a potential match.

IMPLEMENTATION NOTES
The Sun Solaris implementation utilised procfs to obtain process information. This implementation utilises kvm(3) instead.

EXIT STATUS
pgrep, pkill, and prenice return one of the following values upon exit:

0   One or more processes were matched.

1   No processes were matched.

2   Invalid options were specified on the command line.

3   An internal error occurred.

SEE ALSO
grep(1), kill(1), ps(1), kill(2), sigaction(2), kvm(3), re_format(7), signal(7), renice(8)

HISTORY
pkill and pgrep first appeared in NetBSD 1.6. They are modelled after utilities of the same name that appeared in Sun Solaris 7.

prenice was introduced in NetBSD 6.0.

AUTHORS
Andrew Doran <ad@NetBSD.org>.